>From 3639bf66ff5380a7704588b5e1d3a19dcfb16cd1 Mon Sep 17 00:00:00 2001
From: amit <amitlangote09@gmail.com>
Date: Fri, 18 Mar 2016 15:54:17 +0900
Subject: [PATCH 4/6] Infrastructure for partition metadata storage and manipulation.

Catalog pg_partition with:

  partrelid		oid
  partbound		pg_node_tree

Now since partition metadata is stored in a dedicated catalog, it is possible
to use that knowledge to enforce special behaviors for inheritance children
(or relations in general) that are partitions. Some such behaviors include:

 * Cannot drop using DROP TABLE without first "detaching" from its parent
 * Cannot add, drop new columns
 * Cannot rename, change type of existing columns

It also becomes now possible to check, from the FOR VALUES specification, that
the new partition (in CREATE TABLE PARTITION OF parent or ALTER TABLE parent
ATTACH PARTITION) does not overlap with any existing partition of parent.

One can get a partition's check expression (that is, an expression tree that
can be used as a check constraint for the rows in it).  ExecConstraints() now
checks using that expression, whether a row being inserted or new row value in
update case, violate the partition boundary specification.  Also, optimizer's
constraint exclusion uses it remove useless partitions.  This expression tree
is cached in the partition's relcache.

When attaching a partition, rows in the table are checked whether any violates
the partition bound specification (AND'ed with the parent's check expression,
if parent itself is a partition), unless NO VALIDATE clause is specified with
the command.

This commit also invents an internal representation of partition bounds in
the form of structs PartitionListBound and PartitionRangeBound, which consist
of datums and information like number of values in a list, booleans for
whether a range bound is infinite, inclusive (vs. exclusive), lower bound
(vs. upper bound), etc. One can get "partition descriptor" for a partitioned
table, which comes in the form of a struct PartitionDesc.  It consists of
of an array of oids of partitions, array of pointers to PartitionListBound
structs (NULL if not list partitioned, and 2 arrays of pointers to
PartitionRangeBound structs, (each NULL, if not range partitioned).
A pointer to this structure is also cached in relcache.

One more data structure that this commit invents for future use is struct
PartitionDescNode.  It represents a node in partition tree where each node
of the tree corresponds to a partitioned table in the tree.  The tree
structure is such that a parent node links to the first child node (which
corresponds with the first partition of the parent that is partitioned
itself), which in turn, links to its right sibling (the next partition
that is partitioned) and so on.  Each node consists of some book-keeping
information including a pointer to PartitionDesc of the corresponding table
and recursive pointers just mentioned viz. downlink and next.

Support to route tuples inserted into a partitioned parent to the appropriate
leaf partition will be added shortly which leverages PartitionDescNode.
---
 doc/src/sgml/catalogs.sgml                 |   56 +
 src/backend/catalog/Makefile               |    2 +-
 src/backend/catalog/heap.c                 |    6 +
 src/backend/catalog/partition.c            | 1531 ++++++++++++++++++++++++++++
 src/backend/commands/copy.c                |    2 +-
 src/backend/commands/lockcmds.c            |    4 +-
 src/backend/commands/tablecmds.c           |  210 ++++-
 src/backend/executor/execMain.c            |   75 ++-
 src/backend/executor/nodeModifyTable.c     |    4 +-
 src/backend/nodes/readfuncs.c              |   33 +
 src/backend/optimizer/util/plancat.c       |   13 +
 src/backend/parser/analyze.c               |    1 +
 src/backend/parser/parse_clause.c          |    4 +-
 src/backend/parser/parse_relation.c        |    3 +-
 src/backend/parser/parse_utilcmd.c         |    6 +
 src/backend/utils/adt/ruleutils.c          |   78 ++
 src/backend/utils/cache/relcache.c         |    7 +
 src/backend/utils/cache/syscache.c         |   12 +
 src/bin/pg_dump/common.c                   |   86 ++
 src/bin/pg_dump/pg_dump.c                  |   98 ++-
 src/bin/pg_dump/pg_dump.h                  |   12 +
 src/bin/psql/describe.c                    |   46 +-
 src/include/catalog/indexing.h             |    3 +
 src/include/catalog/partition.h            |   57 +
 src/include/catalog/pg_partition.h         |   54 +
 src/include/nodes/execnodes.h              |    4 +
 src/include/utils/rel.h                    |    4 +
 src/include/utils/syscache.h               |    1 +
 src/test/regress/expected/sanity_check.out |    1 +
 29 files changed, 2377 insertions(+), 36 deletions(-)
 create mode 100644 src/include/catalog/pg_partition.h

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index 652f779..9e7c1d9 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -224,6 +224,11 @@
      </row>
 
      <row>
+      <entry><link linkend="catalog-pg-partition"><structname>pg_partition</structname></link></entry>
+      <entry>information about partitions</entry>
+     </row>
+
+     <row>
       <entry><link linkend="catalog-pg-partitioned"><structname>pg_partitioned</structname></link></entry>
       <entry>information about partitioned tables, including the partition key</entry>
      </row>
@@ -4677,6 +4682,57 @@
 
  </sect1>
 
+ <sect1 id="catalog-pg-partition">
+  <title><structname>pg_partition</structname></title>
+
+  <indexterm zone="catalog-pg-partition">
+   <primary>pg_partition</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_partition</structname> stores partition bounds
+   of tables that are partitions.
+  </para>
+
+  <table>
+   <title><structname>pg_partition</> Columns</title>
+
+   <tgroup cols="4">
+    <thead>
+     <row>
+      <entry>Name</entry>
+      <entry>Type</entry>
+      <entry>References</entry>
+      <entry>Description</entry>
+     </row>
+    </thead>
+
+    <tbody>
+
+     <row>
+      <entry><structfield>partrelid</structfield></entry>
+      <entry><type>oid</type></entry>
+      <entry><literal><link linkend="catalog-pg-class"><structname>pg_class</structname></link>.oid</literal></entry>
+      <entry>The OID of the <structname>pg_class</> entry for this partition</entry>
+     </row>
+
+     <row>
+      <entry><structfield>partbound</structfield></entry>
+      <entry><type>pg_node_tree</type></entry>
+      <entry></entry>
+      <entry>
+       Expression tree (in <function>nodeToString()</function> representation)
+       for partition boundary value.  For list partitions, it is simply a list
+       of values.  For range partitions, it consists of lower and upper bound
+       values along with their inclusivity.
+      </entry>
+     </row>
+
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
  <sect1 id="catalog-pg-partitioned">
   <title><structname>pg_partitioned</structname></title>
 
diff --git a/src/backend/catalog/Makefile b/src/backend/catalog/Makefile
index 4dc6300..ee1be31 100644
--- a/src/backend/catalog/Makefile
+++ b/src/backend/catalog/Makefile
@@ -41,7 +41,7 @@ POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
 	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
 	pg_foreign_table.h pg_policy.h pg_replication_origin.h \
 	pg_default_acl.h pg_init_privs.h pg_seclabel.h pg_shseclabel.h \
-	pg_collation.h pg_range.h pg_transform.h pg_partitioned.h\
+	pg_collation.h pg_range.h pg_transform.h pg_partitioned.h pg_partition.h\
 	toasting.h indexing.h \
     )
 
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index 932a48b..2e99661 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -1808,7 +1808,13 @@ heap_drop_with_catalog(Oid relid)
 	 * If a partitioned table, delete the pg_partitioned tuples.
 	 */
 	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_REL)
+	{
 		RemovePartitionKeyByRelId(relid);
+		RelationDropPartitions(relid);
+	}
+
+	if (relid_is_partition(relid))
+		RemovePartitionEntryByRelId(relid);
 
 	/*
 	 * Schedule unlinking of the relation's physical files at commit.
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 5e238dc..46bbb9e 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -18,19 +18,26 @@
 #include "access/heapam.h"
 #include "access/htup_details.h"
 #include "access/nbtree.h"
+#include "access/sysattr.h"
 #include "catalog/dependency.h"
 #include "catalog/indexing.h"
 #include "catalog/objectaddress.h"
 #include "catalog/partition.h"
 #include "catalog/pg_collation.h"
+#include "catalog/pg_inherits.h"
+#include "catalog/pg_inherits_fn.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_partitioned.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_type.h"
 #include "executor/executor.h"
 #include "miscadmin.h"
+#include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
+#include "nodes/parsenodes.h"
 #include "optimizer/clauses.h"
 #include "optimizer/planmain.h"
+#include "optimizer/var.h"
 #include "storage/lmgr.h"
 #include "utils/array.h"
 #include "utils/builtins.h"
@@ -41,10 +48,88 @@
 #include "utils/lsyscache.h"
 #include "utils/syscache.h"
 
+/*
+ * Information about a single partition
+ */
+typedef struct PartitionInfo
+{
+	Oid						oid;		/* partition OID */
+	PartitionListBound	   *list;		/* list partition bound */
+	PartitionRangeBound	   *rangelower;	/* range partition lower bound */
+	PartitionRangeBound	   *rangeupper;	/* range partition upper bound */
+} PartitionInfo;
+
+typedef struct translate_var_attno_mutator_context
+{
+	AttrNumber	old_attno;
+	AttrNumber	new_attno;
+} translate_var_attno_mutator_context;
+
+/*
+ * Information about partitions of a partitioned table.
+ */
+typedef struct PartitionDescData
+{
+	int		nparts;		/* number of partitions */
+	Oid	   *oids;		/* OIDs of the partitions */
+	PartitionListBound  **lists;		/* list bounds */
+	PartitionRangeBound **rangelowers;	/* range lower bounds */
+	PartitionRangeBound **rangeuppers;	/* range upper bounds */
+} PartitionDescData;
+
 static PartitionKey CopyPartitionKey(PartitionKey fromkey);
 static KeyTypeCollInfo *copy_key_type_coll_info(int nkeycols,
 								KeyTypeCollInfo *tcinfo);
 static void free_key_type_coll_info(KeyTypeCollInfo *tcinfo);
+static bool list_overlaps_existing_partition(PartitionKey key,
+							PartitionListSpec *list_spec,
+							PartitionDesc pdesc,
+							Oid *with);
+static bool partition_range_empty(PartitionKey key,
+							PartitionRangeSpec *range_spec);
+static int32 compare_range_keys(PartitionKey key, Datum *val1, Datum *val2);
+static bool range_overlaps_existing_partition(PartitionKey key,
+							PartitionRangeSpec *range_spec,
+							PartitionDesc pdesc,
+							Oid *with);
+static PartitionListBound *make_list_from_spec(PartitionKey key, List *values);
+static PartitionRangeBound *make_range_from_spec(PartitionKey key, List *val,
+							bool inclusive, bool lower);
+static bool partition_range_overlaps(PartitionKey key,
+							PartitionRangeBound *part1_lower,
+							PartitionRangeBound *part1_upper,
+							PartitionRangeBound *part2_lower,
+							PartitionRangeBound *part2_upper);
+static int32 partition_range_cmp_bounds(PartitionKey key,
+							PartitionRangeBound *b1,
+							PartitionRangeBound *b2);
+
+static PartitionDesc RelationGetPartitionDesc(Relation relation);
+static PartitionDesc GetPartitionDescCopy(PartitionKey key, PartitionDesc src);
+static PartitionInfo **GetRelPartitions(Relation rel, int *nparts);
+static List *get_partitions(Oid relid, int lockmode);
+static int32 range_partition_cmp_upper(const void *a, const void *b,
+							void *arg);
+static PartitionListBound *copyPartitionListBound(PartitionListBound *src,
+							PartitionKey key);
+static PartitionRangeBound *copyPartitionRangeBound(PartitionRangeBound *src,
+							PartitionKey key);
+static void free_partition_info_array(PartitionInfo **p, int num);
+
+static Expr *get_check_expr_for_list(PartitionKey key, List *values);
+static Expr *get_check_expr_for_range(PartitionKey key,
+						 List *lowervalues,
+						 bool lowerinc,
+						 List *uppervalues,
+						 bool upperinc);
+static Node *translate_var_attno(Node *expr, AttrNumber attno,
+							AttrNumber new_attno);
+static Node *translate_var_attno_mutator(Node *node,
+							translate_var_attno_mutator_context *cxt);
+static Node *generate_partition_check_expr(Relation rel);
+
+static PartitionDescNode GetPartitionDescNodeRecurse(Relation rel, int offset);
+static int get_leaf_partition_count(PartitionDescNode pdnode);
 
 /*
  * StorePartitionKey
